#include <fstream>
#include <algorithm>
#include <deque>
#include <vector>

using namespace std;

ifstream fin("recurenta.in");
ofstream fout("recurenta.out");

void add(vector<int> v1, vector<int> v2, vector<int>& dest)
{
    int lim = max(v1[0], v2[0]);
    fill(dest.begin(), dest.end(), 0);

    for (int i = 1; i <= lim; ++i)
    {
        dest[i] += v1[i] + v2[i];
        dest[0] = i;

        if (dest[i] > 9)
        {
            dest[i + 1] += dest[i] / 10,
            dest[i] %= 10;

            dest[0] = i + 1;
        }
    }
    while (dest[dest[0]] > 9)
    {
        dest[dest[0] + 1] += dest[dest[0]] / 10;
        dest[dest[0]] %= 10;
        ++dest[0];

    }
}

void sub(vector<int> v1, vector<int> v2, vector<int>& dest)
{
    int t = 0;
    fill(dest.begin(), dest.end(), 0);

    for (int i = 1; i <= v1[0]; ++i)
    {
        dest[i] = t + v1[i] - v2[i];
        t = 0;
        if (dest[i] < 0) dest[i] += 10, t = -1;
    }
    while (dest[dest[0]] == 0) --dest[0];
}

void tr(int x, vector<int>& dest)
{
    fill(dest.begin(), dest.end(), 0);

    dest[0] = 0;
    while (x)
    {
        dest[++dest[0]] = x % 10;
        x /= 10;
    }
}

void Read();
void Solve();
void Write();

int n, k;
deque<vector<int> > d;
vector<int> sum(3001);

int main()
{
    Read();
    Solve();
    Write();
}

void Read()
{
    fin >> n >> k;
}

void Solve()
{
    n -= k;
    tr(k, sum);

    vector<int> one(3001); one[0] = 1, one[1] = 1;
    while (k--)
        d.push_front(one);

    while (n--)
    {
        d.push_front(sum);
        sub(sum, d.back(), sum);
        add(sum, d.front(), sum);
        d.pop_back();
    }
}

void Write()
{
    for (int i = sum[0]; i >= 1; --i)
        fout << sum[i];
}

