// Constantin Galatan
// O(D*N*log D)
#include <fstream>
#include <algorithm>
#include <deque>
#include <cmath>
using namespace std;

ifstream fin("stalpi2.in");
const int INF = 1000000000;

void Read();
void Write();
void Bs();
bool Test( int x );

int n, e, max_d, max_dist;
int dist[55];
int a[55][10005];
deque<int> d;

int main()
{
	Read();
	Bs();
	Write();
	return 0;
}

void Read()
{
	
	fin >> n >> e;
	for ( int i = 2; i <= n; ++i )
		fin >> dist[i];
	max_dist = dist[n];
	fin.close();
}

void Write()
{
	ofstream fout("stalpi2.out");
	fout << max_d;
	fout.close();
}

void Bs()
{
	int l = 0, r = max_dist;
	while ( l <= r )
	{
		int mj = ( l + r ) / 2;
		if ( Test( mj ) )
		{
			max_d = mj;
			r = mj - 1;
		}
		else
			l = mj + 1;
	}
}

bool Test( int x )
{
	int i, j;
	for ( i = 1; i <= n; ++i )
		for ( j = 0; j <= max_dist; ++j )
			a[i][j] = INF;
	a[1][0] = 0;

	for ( i = 2; i < n; ++i )
	{
		d.clear();
		for ( j = 0; j <= max_dist; ++j )
		{
			while (!d.empty() && a[i - 1][j] < a[i - 1][d.front()]) 
				d.pop_front();
			d.push_front(j);
			
			while (!d.empty() && d.back() < j - x) 
				d.pop_back();

			if (!d.empty())
				a[i][j] = min( a[i][j], a[i - 1][d.back()] + abs( dist[i] - j ) );
		}
	}

	for ( i = max_dist; i >= max( 1, max_dist - x ); --i )
		if ( a[n - 1][i] <= e )
			return true;

	return false;
}

