#include <stdio.h>

#define NMAX 100100
#define GMAX 1000
#define INF ((long long)NMAX * (long long)GMAX * (long long)NMAX )

int N, K;
int G[NMAX];
long long S[NMAX];
int SG[NMAX];

long long A[2][NMAX];
int q[NMAX];

int s, d; /* source and destination */

inline long long cost(int start, int end) {
  return S[end] - S[start-1] - ((long long)start) * (SG[end] - SG[start-1]);
}

inline double g(int k1, int k2) {
  return (double) (A[s][k1-1] - A[s][k2-1] + cost(k1, k2-1)) / (double)(k2-k1) - SG[k2-1];
}

inline int f(int i) {
  return -SG[i];
}

int main() {
    int i, p, b, v;

    freopen("leaves.in", "r", stdin);
    scanf("%d%d", &N, &K);
    for (i = 1; i <= N; i++)
        scanf("%d", G+i);
    for (i = 1; i <= N; i++)
        SG[i] = SG[i-1] + G[i];
    for (i = 1; i <= N; i++)
        S[i] = S[i-1] + G[i] * i;

    s = 0; d = 1;
    for (i = 1; i <= N; i++)
        A[s][i] = S[i] - SG[i];
    for (p = 2; p <= K; p++) {
        b = 0;
	v = 0;

        for (i = 1; i <= N; i++) {
          while ((v-b) > 1 && g(q[v-1], i) >= g(q[v-2], q[v-1]))
            v--;
          q[v++] = i;

          while ((v-b) > 1 && f(i) <= g(q[b], q[b+1]))
                b++;

          A[d][i] = A[s][ q[b]-1 ] + cost(q[b], i);
        }
        
        s ^= 1; d ^= 1;
    }

    freopen("leaves.out", "w", stdout);
    printf("%lld\n", A[s][N]);

    return 0;
}
